#include <limits.h>
#include "abr.h"

ABR creaABR ()
{
  return EMPTY_TREE;
}


void distruggeABR (ABR *pT)
{
  if (*pT != EMPTY_TREE)
  {
    distruggeABR(&(*pT)->Ts);
    distruggeABR(&(*pT)->Td);
    free(*pT);
    *pT = EMPTY_TREE;
  }
}


boolean ABRvuoto (ABR T)
{
  return (T == EMPTY_TREE);
}


boolean memberABR (int i, ABR T)
{
#ifdef RICORSIVA
  /* Implementazione ricorsiva */
  if (T == EMPTY_TREE)
    return FALSE;
  else if (T->val == i)
    return TRUE;
  else if (i < T->val)
    return memberABR(i,T->Ts);
  else /* if (i > T->val) */
    return memberABR(i,T->Td);*/
#else
  /* Implementazione iterativa */
  while ( (T != EMPTY_TREE) && (T->val != i) )
    if (i < T->val)
      T = T->Ts;
    else /* if (i > T->val) */
      T = T->Td;
#endif

  return (T != EMPTY_TREE);
}


ABR creanodoABR (int i)
{
  nodo *r;

  /* Alloca l'elemento radice */
  r = (nodo *) malloc(sizeof(nodo));
  if (r == NULL)
  {
    fprintf(stderr,"Errore nell'allocazione di un nodo!\n");
    exit(EXIT_FAILURE);
  }

  r->val = i;
  r->padre = NULL;
  r->Ts = NULL;
  r->Td = NULL;

  return r;
}


ABR insertABR (int i, ABR T)
{
  if (T == EMPTY_TREE)
    T = creanodoABR(i);
  else if (i < T->val)
  {
    T->Ts = insertABR(i,T->Ts);
    T->Ts->padre = T;
  }
  else if (i > T->val)
  {
    T->Td = insertABR(i,T->Td);
    T->Td->padre = T;
  }

  return T;
}


ABR deleteABR (int i, ABR T)
{
}


int minABR (ABR T)
{
  /* Implementazione ricorsiva */
  /*if (T == EMPTY_TREE)
    return INT_MAX;
  else if (T->Ts == EMPTY_TREE)
    return T->val;
  else
    return minABR(T->Ts);*/

  /* Implementazione iterativa */
  if (T == EMPTY_TREE) return INT_MAX;
  while (T->Ts != EMPTY_TREE)
    T = T->Ts;
  return T->val;
}


int maxABR (ABR T)
{
  /* Implementazione ricorsiva */
  /*if (T == EMPTY_TREE)
    return INT_MIN;
  else if (T->Td == EMPTY_TREE)
    return T->val;
  else
    return maxABR(T->Td);*/

  /* Implementazione iterativa */
  if (T == EMPTY_TREE) return INT_MIN;
  while (T->Td != EMPTY_TREE)
    T = T->Td;
  return T->val;
}


void stampaABR (ABR T)
{
  if (T != EMPTY_TREE)
  {
    stampaABR(T->Ts);
    printf(" %d",T->val);
    stampaABR(T->Td);
  }
}
